/* mk_outvec.c
** setup header for outvec_STDOUT.c
** use sysconf() for pulling IOV_MAX on platform
** wcm, 2010.12.01 - 2010.12.01
** ===
*/

#include <stdio.h>
#include <unistd.h>

#define _VEC_STDOUT_MIN  16
#define _VEC_STDOUT_MAX  256

const char  progname[] = "mk_outvec";

int
main(int argc, char * argv[])
{
  long  limit = 0;

  (void)argc;
  (void)argv;

  printf("/* outvec_STDOUT.h\n"
         "** automatically generated by %s (%s) \n"
         "*/\n\n", progname, __FILE__ );

  limit = sysconf(_SC_IOV_MAX);

  if(limit >= _VEC_STDOUT_MAX)
      printf("#define _VEC_STDOUT_SIZE  %d\n\n", _VEC_STDOUT_MAX);
  else
      printf("#define _VEC_STDOUT_SIZE  %d\n\n", _VEC_STDOUT_MIN);

  printf("/* eof: outvec_STDOUT.h */\n");

  return 0;
} 

/* eof: mk_outvec.c */
